Const ForReading = 1, ForWriting = 2, ForAppending = 8
Arch = "32"     					        '  
DUpdPath = "D:\Temp\Updates" & Arch & "\"   '      
FSourceName = "Updates.html"		        '   "    Windows 7 SP1"  forum.ru-board.com
FCmdName = "Upd_" & Arch & ".cmd"	        '      
FDiffName = "ToLoad_" & Arch & "_"          '     ,   
UpdDate = ""						        '    

Set FSO = CreateObject("Scripting.FileSystemObject")
Set FSource = FSO.OpenTextFile(FSourceName, ForReading, True)
Set FCmd = FSO.OpenTextFile(FCmdName, ForWriting, True)

FCmd.WriteLine("@echo off") 
FCmd.WriteLine("ECHO.") 
FCmd.WriteLine("ECHO Installing Hotfixes for Microsoft Windows 7") 
FCmd.WriteLine("ECHO -------------------------------------------------")

'  html-:
AllFiles = ""	'      (    )
nk = 1
Do While FSource.AtEndOfStream <> True '    html-
	SourceLine = FSource.ReadLine
	pos1 = InStr(SourceLine,"<br>") '      <br>
	Do While pos1 <> 0	'          html-
		FTempLine = Trim(Mid(SourceLine,1,pos1-1))
		If InStr(FTempLine,"<b> 2</b></font>") <> 0 Then	'    " 2"
			Exit Do
		End If
		If (InStr(FTempLine,".msu") <> 0) or (InStr(FTempLine,".exe") <> 0) Then	'  ,    
			Parsing(FTempLine)
		End If
		SourceLine = Mid(SourceLine,pos1+4)	'     
		pos1 = InStr(SourceLine,"<br>")
	Loop 
Loop
FSource.Close

FCmd.WriteLine("echo.") 
FCmd.WriteLine("echo Done! Please reboot your computer to complete installation!") 
FCmd.WriteLine("echo.")
FCmd.Write("pause")
FCmd.Close

WorkDir = Left(WScript.ScriptFullName,InStrRev(WScript.ScriptFullName,"\"))	'   
FindObsoleteUpdates '         

MsgBox UpdDate

Set f = fso.GetFile(FCmdName) '      
f.Copy(DUpdPath & UpdDate & "_" & Arch & ".cmd")

MsgBox("Done...")

' ===================================================================================
'      
Sub Parsing(Stro)
	Set objRegExp = CreateObject("VBScript.RegExp") '   
	objRegExp.Global = True
	
	'   
	objRegExp.Pattern = "<a href=" & CHR(34) & "http://forum.ru-board.com/microsoft_st/" & CHR(34) & " target=_blank>|</a>|<font color=" & CHR(34) & "#FF0000" & CHR(34) & ">|</font>|&quot;|&nbsp;|</b>"
	Stro = objRegExp.Replace(Stro,"")

	objRegExp.Pattern = "<a href=" & CHR(34) & "http://forum.ru-board.com/mva/" & CHR(34) & " target=_blank>"
	Stro = objRegExp.Replace(Stro,"")
	
	'    
	pos = InStr(Stro,">KB")
	If pos <> 0 Then
		UpdInfo = Mid(Stro,pos+1)
	End If

	'   
	objRegExp.Pattern = "\d{2}\.\d{2}\.\d{2}" ' \d -  , {2} -  2 
	Set objMatches = objRegExp.Execute(Stro)
	
	For i = 0 To objMatches.Count - 1
    	Set objMatch = objMatches.Item(i)
    	'   () &       - &   
    	' MsgBox objMatch.Value & ", " & "FirstIndex=" & objMatch.FirstIndex & ", " & "Length=" & objMatch.Length
    	UpdDate = objMatch.Value
    	UpdYear = Right(UpdDate,2)
	Next
	
	'    
	Pattern = "http://\S*\.(msu|exe).{15,20}\[" & Arch & "\]" ' ,   http://,      (\S*) ,   .msu  .exe,    15-20     [Arch] 
	objRegExp.Pattern = Pattern
	Set objMatches = objRegExp.Execute(Stro)
	
	For i = 0 To objMatches.Count - 1
    	Set objMatch = objMatches.Item(i)
    	UpdLink = objMatch.Value
	Next
	
	If UpdLink <> "" Then
	   pos = InStr(UpdLink,Chr(34))  '    ( )
	   UpdLink = Left(UpdLink,pos-1)
        
  	   pos = InStrRev(UpdLink,"/")	'      
   	   UpdFile = Mid(UpdLink,pos+1)
    	
       WriteIntoFiles nk, UpdFile, UpdLink, UpdYear, UpdInfo
    End If
	nk = nk + 1
End Sub

' ===================================================================================
'   cmd-     
Sub WriteIntoFiles(num,FileName,LinkName,Year,Info)
	If num <= 9 Then '   01, 02, 03  ..
		num_s = "0" & num
	Else
		num_s = num
	End If
	
	Info = ANSItoOEM(Info)
	FCmd.WriteLine("ECHO " & num_s & "-" & Info) '   cmd-
	
	'       cmd-
	If Right(FileName,3) = "msu" Then
	   FCmd.WriteLine("start /wait wusa.exe %~dp0Update" & Year & "\" & FileName & " /quiet /norestart") 
	Else
	   prov = Left(FileName,6)
	   Select Case prov
	       Case "rvkroo" FCmd.WriteLine("start /wait %~dp0Update" & Year & "\" & FileName & " /Q")
	       Case "msxml4" FCmd.WriteLine("start /wait %~dp0Update" & Year & "\" & FileName & " /quiet /norestart")
	       Case Else MsgBox "Check update: " & nk & " " & FileName
	   End Select
	End If
	
	AllFiles = AllFiles & FileName & "#" '         
	
	If not FSO.FileExists(DUpdPath & "Update" & Year & "\" & FileName) Then '         
		Set FDiff = FSO.OpenTextFile(FDiffName & Year & ".txt", ForAppending, True)
        FDiff.WriteLine(LinkName) '        ( )
		FDiff.Close
    End If  
End Sub

' ===================================================================================
'      (), ..    GetFolder  
Sub FindObsoleteUpdates()
	Set DSet = FSO.GetFolder(DUpdPath)
	For Each D In DSet.SubFolders	'       
		FindFiles(DUpdPath & D.Name) '        
	Next
End Sub

' ===================================================================================
'      
Sub FindFiles(Dir)
	Set FSet = FSO.GetFolder(Dir)
	For Each F In FSet.Files
		If InStr(AllFiles,F.Name) = 0 Then '  cmd-      -   
			FSO.MoveFile F,WorkDir '           
		End If
	Next
End Sub

' ===================================================================================
'   (http://www.sql.ru/forum/actualthread.aspx?tid=374964)
Function CharANSItoOEM(symbol)
 	code = Asc(symbol)
 	If ((code >= 176) and (code <= 239)) Then
		If (code = 185) then
			res = Chr(code+67)
		Else
	        res = Chr(code-64)
		End If
 	Else
 		If ((code >= 240) and (code <= 255)) Then
      		res = Chr(code-16)
	 	Else
      		res = symbol
 		End If
 	End If
 	CharANSItoOEM = res
End Function

' ===================================================================================
'   (http://www.sql.ru/forum/actualthread.aspx?tid=374964)
Function ANSItoOEM(st)
	slen = Len(st)
	i = 0
	tmp = ""
 	While (i < sLen)
      	i = i + 1
      	tmp = tmp + CharANSItoOEM(Mid(st,i,1))
 	Wend
 	ANSItoOEM = tmp
End Function